from re import X
from xlsxwriter import workbook
import management
from time import sleep
from django.shortcuts import redirect, render
from datetime import date, datetime, timedelta
from pos.models import *
from management.models import Product
from django.contrib.auth.decorators import login_required
from management.permission_page import pos_manager_only
import xlsxwriter 
import glob
from icecream import ic
# Create your views here.

# https://linuxhint.com/download-the-file-in-django/
import mimetypes
# import os module
import os
# Import HttpResponse module
from django.http.response import HttpResponse


def download_file(request, filename=''):
    if filename == '':
        filename = 'constFile/example_for_add_product.xlsx'
    path = open(filename, 'rb')
    # Set the mime type
    mime_type, _ = mimetypes.guess_type(filename)
    # Set the return value of the HttpResponse
    response = HttpResponse(path, content_type=mime_type)
    # Set the HTTP header for sending to browser
    response['Content-Disposition'] = "attachment; filename=%s" % filename
    # Return the response value
    return response
    

@login_required
@pos_manager_only
def dashborad(req):
    context=dict()
    userlabel = str(req.user.id)+'_'+str(req.user)
    print('------------------------------------xlsx file --------------------------------------------------')
    for name in glob.glob('*.xlsx'):
        print(name)
        try:
            if userlabel in name:
                os.remove(name)
        except:

            print("can't delete filename:",name)

    if req.method == 'POST':
        #pick time range
        print(req.POST)
        context['mode'] = 'post'
    else :
        strnowtime = datetime.now().strftime("%Y%m%d%H%M%S")
        labelfilexlsx = userlabel+'_'+strnowtime
        today_filename = 'today_of_'+labelfilexlsx+'.xlsx'
        last_week_filename = 'last_week_of_'+labelfilexlsx+'.xlsx'
        last_month_filename = 'last_month_of_'+labelfilexlsx+'.xlsx'
        context['today_filename'] = today_filename
        context['last_week_filename'] = last_week_filename
        context['last_month_filename'] = last_month_filename
        context['today'] = billlistsNdays(filename=today_filename)
        context['week'] = billlistinrange(date.today() - timedelta(days=7),date.today(),last_week_filename)
        context['month'] = billlistinrange(date.today() - timedelta(days=30),date.today(),last_month_filename)
    return render(req,'dashboard.html',context)

def billlistinrange(start,end,filename=''):
    bills = Bill.objects.filter(created__gte=start).filter(created__lt=end)
    data = dict()
    soldValueInDay = dict()
    dataset = dict()
    nday = (end-start).days
    sumSoldValue = 0
    for i in bills:
        listsInBill = BillList.objects.filter(bill=i)
        datekey = i.created.strftime('%d/%m/%Y')
        if soldValueInDay.get(datekey) == None : soldValueInDay[datekey] = 0
        for j in listsInBill:
            v = j.product.price * j.quantity
            soldValueInDay[datekey] += v
            sumSoldValue += v
            if dataset.get(j.product.id) != None:
                # print(dataset.get(j.product.id))
                dataset[j.product.id]['sold']+=int(j.quantity)
            else :
                # id : autoincrement field in db
                dataset[j.product.id] = {
                    'id':j.product.product_id,
                    'name':j.product.name,
                    'price':j.product.price,
                    'sold':j.quantity
                }
    if filename!='': 
        workbook = xlsxwriter.Workbook(filename)
        sheet_by_day = workbook.add_worksheet('days')
        sheet_by_product = workbook.add_worksheet('products')
        columns_by_p = [
            {'header':'id'},
            {'header':'name'},
            {'header':'price'},
            {'header':'sold'},
            {'header':'value'},
            {'header':'sold/day'},
            {'header':'value/day'},
               
        ]
        columns_by_d = [
            {'header':'day'},
            {'header':'value'},
            
        ]

        product_tableArea = 'A1:G'+str(len(dataset.keys())+1)
        sheet_by_product.add_table(product_tableArea,{'columns':columns_by_p,'style':None})
        row_counter = 2
    for key in dataset.keys():
        tmp = dataset[key]
        val = tmp['price'] * tmp['sold']
        tmp['value'] = val
        tmp['soldperday'] = round(tmp['sold']/nday,2)
        tmp['valueperday'] = round(val/nday,2)
        dataset[key] = tmp
        if filename!='':
            cellstr = 'A'+str(row_counter)
            sheet_by_product.write_row(cellstr,list(tmp.values()))
            row_counter+=1
    if filename!='':
        keysol = list(soldValueInDay.keys())
        day_tableArea = 'A1:B'+str(len(keysol)+1)
        sheet_by_day.add_table(day_tableArea,{'columns':columns_by_d, 'style':None})
        for i in range(len(keysol)) :
            cellstr = 'A'+str(i+2)
            sheet_by_day.write_row(cellstr,[keysol[i],soldValueInDay.get(keysol[i])])
       
        workbook.close()

    data['dataProduct'] = dataset
    data['soldValueInDay'] = soldValueInDay
    x_axis = []
    y_axis = []
    for i in range(nday):
        k = (start+timedelta(days=i)).strftime('%d/%m/%Y')
        x_axis.append(k)
        y_axis.append(0) if soldValueInDay.get(k) == None else y_axis.append(float(soldValueInDay.get(k)))  

    data['avgSoldValue'] = [round(float(sumSoldValue)/nday,2)]*nday
    data['labels'] = x_axis
    data['data'] = y_axis

    return data
            



def billlistsNdays(n=0,filename=''):
    start_date = date.today() - timedelta(days=n)
    bills = Bill.objects.filter(created__gte=start_date)
    dataset = {}
    for i in bills:
        listsInBill = BillList.objects.filter(bill=i)
        for j in listsInBill:
            if dataset.get(j.product.id) != None:
                # print(dataset.get(j.product.id))
                dataset[j.product.id]['sold']+=int(j.quantity)
            else :
                # id : autoincrement field in db
                dataset[j.product.id] = {
                    'id':j.product.product_id,
                    'name':j.product.name,
                    'price':j.product.price,
                    'sold':j.quantity
                }
    if filename!='':
        workbook = xlsxwriter.Workbook(filename)
        sheet = workbook.add_worksheet('products')
        columns_table = [
                {'header':'id'},
                {'header':'name'},
                {'header':'price'},
                {'header':'sold'},
                {'header':'value'}
            ]
        
        tableArea = 'A1:E'+str(len(dataset.keys())+1)
        sheet.add_table(tableArea,{'style':None,'columns':columns_table})
        row_counter=2
    for key in dataset.keys():
        dataset[key]['value'] = dataset[key]['price'] * dataset[key]['sold']
        if filename != '' :
            cellstr = 'A'+str(row_counter)
            sheet.write_row(cellstr,dataset[key].values())
    if filename!='':
        workbook.close()

    return dataset