from django.db import models
from django.db.models.constraints import UniqueConstraint
from management.models import Product,POSManager
from django.contrib.auth.models import User
from django.dispatch import receiver
from django.db.models.signals import post_save, pre_save,pre_delete
import pytz
class Bill(models.Model):
    created = models.DateTimeField(editable=True)
    user = models.ForeignKey(User,on_delete=models.RESTRICT)
    manager = models.ForeignKey(POSManager,on_delete=models.CASCADE)
    class Meta:
        unique_together = (("created","user"),)
    def __str__(self):
        return str(self.user.username)+' : '+str(self.created.astimezone(pytz.timezone('Asia/Bangkok')))
class BillList(models.Model):
    product = models.ForeignKey(Product,on_delete=models.RESTRICT)
    quantity = models.IntegerField()
    bill = models.ForeignKey(Bill,on_delete=models.CASCADE,blank=True)
    def __str__(self):
        return str(self.product.name)+' '+str(self.quantity)

class FeaturePic(models.Model):
    urlPic = models.TextField()


    
@receiver(pre_delete,sender=BillList)
def role_back_product_from_billlist(sender, instance ,**kwargs):
        iproduct = Product.objects.get(id=instance.product.id)
        iproduct.quantity += int(instance.quantity)
        iproduct.save()