import django
from django.db.models.manager import Manager
from pos.models import Bill, BillList, FeaturePic
from django import dispatch
from django.shortcuts import redirect, render
from management.models import EmployeeUser, POSManager, Product
import json
from allauth.account.forms import LoginForm
from django.views.decorators.csrf import csrf_protect
from django.contrib.auth import authenticate,login,logout
from django.contrib.auth.decorators import login_required
from datetime import *
import pytz
# from management.permission_page import allow_by_role 


django.utils.timezone.activate(pytz.timezone('Asia/Bangkok'))
# https://stackoverflow.com/questions/21925671/convert-django-model-object-to-dict-with-all-of-the-fields-intact
from itertools import chain

def to_dict(instance):
    opts = instance._meta
    data = {}
    for f in chain(opts.concrete_fields, opts.private_fields):
        if f.name == 'price' :
            data[f.name] = str(f.value_from_object(instance))
        else:
            data[f.name] = f.value_from_object(instance)
    for f in opts.many_to_many:
        data[f.name] = [i.id for i in f.value_from_object(instance)]
    return data



# Create your views here.
@login_required
# @allow_by_role(roles=['manager','employee'])
def pos_page(req):
    mgr_user = None
    if req.user.groups.filter(name = 'manager').exists():
        mgr_user = POSManager.objects.get(user=req.user)
    else :
        emp_user = EmployeeUser.objects.get(user=req.user)
        mgr_user = POSManager.objects.get(emp_user.create_by)
    if req.method == 'POST':
        list_productId = req.POST.getlist('list_productID')
        list_productQuantity = req.POST.getlist('list_productQuantity')
        
        bill = Bill(
            created=datetime.now(),
            user=req.user,
            manager=mgr_user)
        bill.save()
        for i in range(len(list_productId)):
            iproduct = Product.objects.get(id=list_productId[i])
            iproduct.quantity -= int(list_productQuantity[i])
            iproduct.save()
            BillList(
                product=Product.objects.get(id=list_productId[i]),
                quantity=list_productQuantity[i],
                bill=bill
                ).save()
            return redirect('pos')

    productCategory = Product.objects.filter(manager=mgr_user.user).values_list('category').distinct() 
    productsById = dict()

    productCategory = [i[0] for i in productCategory]

    productDict = {}
    for i in productCategory :
        k = Product.objects.filter(category=i,manager=req.user)

        kl = []
        for j in list(k):
            kl.append(to_dict(j))
            productsById[j.id] = to_dict(j)

        productDict[i]=kl

    return render(req,'pos_page.html',{'productCate':productCategory,'productDict':productDict,'productsById':productsById})

@csrf_protect
def home(req):
    login_form = LoginForm()
    mgr_user = None
    if req.user.groups.filter(name = 'manager').exists():
        try:
            mgr_user = POSManager.objects.get(user=req.user)
        except:
            POSManager(user=req.user).save()
    # if req.user.is_authenticated:
    # # Do something for authenticated users.
    #     print('logining')
    # else:
    #     if req.method == 'POST':
    #         form = LoginForm(req.POST, req.FILES)
    #         if form.is_valid():
    #             print(req.POST)
    #             print(req.POST['login'],req.POST['password'])
                
    #             user = authenticate(username=req.POST['login'], password=req.POST['password'])
    #             if user is not None:
    #                 login(req,user)
    #                 print('login have user')
    #                 # user.lo
    #                 # A backend authenticated the credentials
    #             else:
    #                 print('nope')
    #                 # No backend authenticated the credentials
    #             # username = req.FILES['']
    #             # password = 
    #             # newdoc.save()
    #             # print(request.FILES['docfile'])
    #             # print(newdoc.docfile)
                
    #             # Redirect to the document list after POST
    #             # return redirect('test')
    #         else:
    #             message = 'The form is not valid. Fix the following error:'
    #             print(message)
    #     else:
    #         print('ไม่มีpost')
        
    
    
    #     # Do something for anonymous users.
    featurePic = FeaturePic.objects.all().values_list('urlPic')

    return render(req,'home.html',{'login_form':login_form,'featurePic':featurePic})


