"""webproject URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.contrib import admin
from django.urls import path, include
from pos import views as pos_views
from management import views as management_views
from management import permission_page as pp
from dashboard import views as dashboard_views
urlpatterns = [
    path('admin/', admin.site.urls,name='admin'),
    path('pos/',pos_views.pos_page,name='pos'),
    path('', pos_views.home,name='home'),
    path('accounts/', include('allauth.urls')), 
    path('management/employee/',management_views.manage_employee,name='manage_employee'),
    path('management/addproduct/',management_views.add_product,name='add_product'),
    path('management/product/',management_views.show_products,name='show_product'),
    path('management/editproduct/<int:id>/', management_views.ProductUpdateView.as_view(), name='editproduct'),
    path('management/deleteproduct/<int:id>/', management_views.ProductDeleteView.as_view(), name='deleteproduct'),
    path('management/deleteemployee/<int:id>/', management_views.EmployeeDeleteView.as_view(), name='deleteemployee'),
    path('gamaimeesit/',pp.gamaimeesit,name='GaMaiMeeSit'),
    path('dashboard/',dashboard_views.dashborad,name='dashboard'),
    path('download/<str:filename>/',dashboard_views.download_file,name='download'),
    path('management/bills/',management_views.show_bills,name='bills'),
    path('management/deletebill/<int:id>/',management_views.BillDeleteView.as_view(),name='deletebill'),
]
